#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    vector<pair<int,int>>b;
    int prvi,drugi;
    cin>>n>>m;
    int minm,maxm;
    cin>>minm>>maxm;
    int rez=0;
    int a[50002];
    int popunjeni=0;
    for(int i=0;i<m;i++)
    {
        cin>>prvi>>drugi;
        b.push_back(make_pair(prvi,drugi));
        rez+=prvi;
        if(prvi!=0)
            popunjeni++;
        a[i]=prvi;
    }

    for(int i=0;i<m&&(maxm-rez!=0);i++)
        {

            int h=min(b[i].second-a[i],maxm-rez);
            rez+=h;
            if(a[i]==0&&h!=0)
                popunjeni++;
            a[i]+=h;

        }
    cout<<rez<<"\n";
    cout<<popunjeni<<"\n";
    for(int i=0; i<m;i++)
    {
        if(a[i]!=0)
            cout<<1<<" "<<i+1<<" "<<a[i]<<"\n";
    }




    return 0;
}